﻿//this file contains all JS logic for ticket page. It was included into view-pages before, simply moved it here.
//Before including this file into page make sure you init "HDApp" object with stuff needed (see ViewTicket.cshtml)

var HDApp = HDApp || { IsTech: false, IsWindowsAuth: false, TicketId: 0 }; //stub just for intellisense

//adding some utility methods
HDApp.Url = window.location.href.substring(0, window.location.href.toLowerCase().lastIndexOf("/ticket/") + 1);
HDApp.IsSmartphoneOrTablet = /Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent); 

//need this to set cursor after the greeting template
$.fn.selectRange = function(start, end) {
	return this.each(function() {
		this.focus();
		this.setSelectionRange(start, end);
	});
};

function InitCommentsBlock() {
	if (isDraftAvailable()) {
		HDApp.InitialCommentText = getCommentDraft();
		ShowNewComment();
	}
	else
		HDApp.InitialCommentText = HDApp.IsActiveChat ? "" : greetingAndSignature;

	$("#tbNewComment").val(HDApp.InitialCommentText);

	//initializing richtext wysiwyg editor and add keyup/down processors (if NOT A MOBILE DEVICE or tablet)//
	$("#tbNewComment").wswgEditor();
	if(!HDApp.IsSmartphoneOrTablet)
	{
		$(wswgEditor.getEditorDoc()).bind('keyup', function(e) { AutoResizeEditableIframe(wswgEditor.getEditorDoc()); }); //autoresize
		$("#tbNewComment").bind('keyup', function(e) { AutoResize($("#tbNewComment").get(0)); }); //autoresize
	}

	if (typeof wswgEditor !== 'undefined') {
		$(wswgEditor.getEditorDoc()).keydown(function (e) {
			editorKeydownHandler(e);
		});
	}

	$("#tbNewComment").keydown(function (e) {
		editorKeydownHandler(e);
	}); 

	setInterval(function () {
		saveCommentDraft();
	}, 30000);

	//add autocomplete forr the add-subscriber searchbox and change-submitter
	if (HDApp.IsTech || HDApp.IsManager || HDApp.IsWindowsAuth)
	{
		$("#tbNewSubscriber").autocomplete(HDApp.Url + 'User/AutoComplete', {
			delay: 200,
			onItemSelect: function(li) {
				var userId = li.extra[0];
				var userName = li.selectValue;
				var isTech = false;
				AddSubscriber(userId, userName, isTech);

				//check if the user is a tech and update the UI
				$.ajax({
					url: HDApp.Url + "User/IsAdminOrTechInCategory/" + userId + "?categoryid=" + HDApp.CategoryId,
					success: function (data) {
						isTech = data == "1";
						var sub = HDApp.Subscribers.filter(function (u) { return u.UserID == userId });
						if(sub.length)
							sub[0].IsTech = isTech;
					},
				});
			}
		});
		//mentions
		var tribute = new Tribute({
			values: function (text, cb) {
				var xhr = new XMLHttpRequest();
				xhr.onreadystatechange = function () {
					if (xhr.readyState === 4) {
						if (xhr.status === 200) {
							var data = JSON.parse(xhr.responseText);
							cb(data);
						} else
							cb([]);
					}
				};
				xhr.open("GET", HDApp.Url + "User/AutoComplete?q=" + text + "&allTechs=true&json=true", true);
				xhr.send();
			},
			lookup: 'FullName',
			noMatchTemplate: function () { return null; },
			selectTemplate: function (item) {
				return '<a data-mentioneduserid="' + item.original.UserID + '" title="' + item.original.Username + '">@' + item.original.FullName + "</a>";
			},
		});
		tribute.attach(wswgEditor.getEditorDoc());
	}

	$("#tbNewSubscriber").keypress(function (event) {
		if (event.which == 13) {
			addSubscriberFromTB();
			event.preventDefault(); //to prevent from submitting the form when hitting "enter"
			return false;
		}
	});

	$("#addSubscriberMobileBtn").click(function () { addSubscriberFromTB(); });

	$("#cbTechsOnly").change(function() {
		subscribersApp.ForTechsOnly = $(this).is(":checked");
		if (subscribersApp.ForTechsOnly) {
			subscribersApp.Subscribers.forEach(function (s) { s.Checked = s.IsTech; }); //change VUE-binded model property tp update checkboxes
			document.getElementById("usign")?.remove(); //remove signature (popular request)
		} else {
			subscribersApp.Subscribers.forEach(function (s) { s.Checked = true; });
		}
	});

	if ($("#ticketBody").find("div[data-merged-id]").length) $("#liUnmerge").show(); //the ticket is merged, show the "unmerge" button

	//double click prevention
	$("#htmlBtnAdd").on("click", function () { $(this).prop("disabled", true); setTimeout(function () { $("#htmlBtnAdd").removeAttr("disabled"); }, 1000); });
	$("#htmlBtnAddAndResolve").on("click", function () { $(this).prop("disabled", true); setTimeout(function () { $("#htmlBtnAddAndResolve").removeAttr("disabled"); }, 1000); } );

	//reinit mutlifile upload after postback
	//InitMultiFile(); //the func is defined at HDHelpers
}

function addSubscriberFromTB() {
	var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
	if (!re.test($("#tbNewSubscriber").val().trim())) {
		$("#emailValidationError").show();
		return;
	}
	AddSubscriber(0, $("#tbNewSubscriber").val(), false);
}

function subCheckClick(event) {
	if (event.shiftKey) {
		$('#divSubscribersList input').prop('checked', event.target.checked);
	}
}

var isUnloadBound = false;
var isCurrentlyTyping = false;
var currentlyTypingTimeout = null;
function editorKeydownHandler(event) {
	if (!isUnloadBound && event.keyCode != 116) {
		$(window).on("beforeunload", UnloadConfirm);
		isUnloadBound = true;
	}

	if (event.key && (event.key.length == 1 || event.key == "Delete" || event.key == "Backspace" || event.key == "Tab")) //not "control" keys, only keys that affect text, also event.key can be undefined for some reason (mobile browsers??)
		hasUnsavedDraftChanges = true;

	ProcessCtrlEnter(event, function () { //ctrl+enter
		wswgEditor.doCheck();
		$("#htmlBtnAdd").click();
	}, function () { //ctrl+shift+enter
		if (!$("#htmlBtnAddAndResolve").length) return;
		wswgEditor.doCheck();
		$("#htmlBtnAddAndResolve").click();
	});

	// someone is typing indicator	
	if (!isCurrentlyTyping && typeof _connection !== 'undefined' && _connection.state === signalR.HubConnectionState.Connected) { //_conn can be undefined b/c it initialized in "load" only
		isCurrentlyTyping = true;
		_connection.invoke("startTyping", HDApp.TicketId, HDApp.CurrentUserFullName);
	}

	clearTimeout(currentlyTypingTimeout);
	currentlyTypingTimeout = setTimeout(function () {
		isCurrentlyTyping = false;
		if (_connection.state == signalR.HubConnectionState.Connected)
			_connection.invoke("stopTyping", HDApp.TicketId, HDApp.CurrentUserFullName);
	}, 5000);

	// canned response and KB dropdown hotkeys
	if (event.ctrlKey) {
		if (event.code == 'Comma') {
			openCannedRespDropdownExternal();
		}
		else if (event.code == 'Period') {
			openKBDropdown();
		}
	}
}

var hasUnsavedDraftChanges = false;
var DRAFT_STORAGE_KEY = "draft" + HDApp.TicketId;

function saveCommentDraft() {
	if (!hasUnsavedDraftChanges) return;
	if (!window.localStorage) return;

	wswgEditor.doCheck();
	localStorage.setItem(DRAFT_STORAGE_KEY, document.getElementById("tbNewComment").value);
	hasUnsavedDraftChanges = false;
}

function getCommentDraft() {
	if (!window.localStorage) return "";

	return localStorage.getItem(DRAFT_STORAGE_KEY);
}

function removeCommentDraft() {
	if (!window.localStorage) return;

	hasUnsavedDraftChanges = false;
	localStorage.removeItem(DRAFT_STORAGE_KEY)
}

function isDraftAvailable() {
	if (!window.localStorage) return false;

	var draft = localStorage.getItem(DRAFT_STORAGE_KEY);
	return draft && draft.trim();
}

var greetingAndSignature = ""; 
var windowVisible = true; //is tab visible?

var currentlyTypingUsernames = [];
$(function () {
	$(window).on("beforeunload", saveCommentDraft);

	greetingAndSignature = $("#tbNewComment").val().replace("#FirstName#", $("#lnkFrom").data("firstname")).replace("#LastName#", $("#lnkFrom").data("lastname"));

	//if ticket is deleted revove everything except for "undelete" button and get out
	if (HDApp.StatusId == -1) {
		$("body").append('<div id="overlay" style="background-color:grey;position:fixed;top:0;left:0;height:100%;width:100%;z-index:999;opacity:0.4"></div>');
		$('#btnUndelete').css({ 'position': 'relative', 'z-index': '1000' });
		$('#divBigHeader').css({ 'position': 'relative', 'z-index': '1000' });
		$('#btnDeletePermanently').css({ 'position': 'relative', 'z-index': '1000' });
		$('.commentBody a:contains("##")').css({ 'position': 'relative', 'z-index': '1000' });
		return;
	}

	//subscribers vue app
	HDApp.Subscribers = Vue.reactive(HDApp.Subscribers); //make subscribers array reactive for Vue3
	window.subscribersApp = Vue.createApp({
		data() { return { Subscribers: HDApp.Subscribers, ForTechsOnly: false } }
	}).mount("#divSubscribersList");

	//kb-inserter Vue app
	window.vueKb = Vue.createApp({
		data() { return { KbCategories: [], quickSearchStr: "" } },
		methods: {
			pasteKbLink: function (id, subj) { PasteKBLink(id, subj); },
			pasteKbText: function (articleId) {
				pasteKbText(articleId);
			}
		},
		computed: {
			filteredCategories: function() { //quicksearch filter
				return this.KbCategories.filter(function (cat) {
					if (vueKb.quickSearchStr.length > 0)
						cat['shown'] = true; //expand all if we're quick-searching. using Vue-setter b/c of reactivity
					cat.filteredArticles = cat.Articles.filter(function (a) { return a.Subject.toLowerCase().indexOf(vueKb.quickSearchStr.toLowerCase()) > -1; });
					return cat.filteredArticles.length > 0;
				});
			}
		}
	}).mount("#selKb");

	InitCommentsBlock();

	$("#selKb").on("dropdown:show", function () {
		$('#kbFilter').focus();
	});

	// move the canned-reponses and KB-picker inside the editor
	$('#selKb').insertBefore("#divNewComment .boldbtn");
	$('#selTemplates').insertBefore("#divNewComment .boldbtn");
	$('#gptbtn').insertBefore("#divNewComment .boldbtn");

	$(document).ajaxStop(function () {
		$("#ajaxLoader").hide();
	});

	if (HDApp.IsTech) {
		$("div#body input[type=checkbox]").on("click", function () { //save checkboxes interactively
			if (this.checked) //reflect the change in html
				this.setAttribute("checked", "checked");
			else
				this.removeAttribute("checked");

			let body = $("div#body").html(); //get html

			$.post(HDApp.Url + "Ticket/EditTicket", { id: HDApp.TicketId, Body: body, SkipDiffFile: true });
		});
	}
	else {
		$("div#body input[type=checkbox]").prop("disabled", true);
	}

	//is tab hidden?
	onVisibilityChange(function (visible) {
		windowVisible = visible;
		if (visible && document.title.indexOf("* ", 0) == 0) { //remove the star (it its there)
			document.title = document.title.substring(2);
			setTimeout(function () { $(".ticketComment.highlight").removeClass("highlight"); }, 5000);
		}
	});

	//next/prev keyboard shortcuts
	$(document.body).keypress(function (event) {
		if (event.target == document.body) {
			if (event.key == 'k') $('#btnNext')[0].click();
			if (event.key == 'j') $('#btnPrev')[0].click();
			if (event.key == 'r') { event.preventDefault(); ShowNewComment(); }
		}
	});

	$('#formClose').submit(function () {
		stopSignalrConnection(); //perf: disconnect from SignalR on close to stop rendering comments etc.
	});

	$(".scrollToTop").click(function () {
		window.scroll({ top: 0, behavior: "smooth" });
	})

	ExpandYoutubeAndVimeo("#body,.commentBody");
});

function stopSignalrConnection() {
	if (typeof _connection !== 'undefined') _connection.stop();
}

function pasteKbText(articleId) {
	$.post(HDApp.Url + "KB/GetKBArticleText?id=" + articleId, function (data) {
		wswgEditor.InsertText(data);
		AutoResizeEditableIframe(wswgEditor.getEditorDoc());
	});
}

function openKBDropdown() {
	loadKBArticles();
	$("#selKb").addClass('open');
	$('#kbFilter').focus();
}

//intercept copy event and remove formatting otherwise adds dark theme styles etc
if ($("link[href*='_dark']").length) { //are we in dark mode?
	document.addEventListener('copy', function (e) {
		var html = getSelectionHtml();
		if (html && html.trim()) { //IE?
			e.clipboardData.setData('text/plain', window.getSelection().toString());
			e.clipboardData.setData('text/html', html);
			e.preventDefault();
		}
	});
}

function getSelectionHtml() {
	var html = "";
	if (typeof window.getSelection != "undefined") {
		var sel = window.getSelection();
		if (sel.rangeCount) {
			var container = document.createElement("div");
			for (var i = 0, len = sel.rangeCount; i < len; ++i) {
				container.appendChild(sel.getRangeAt(i).cloneContents());
			}
			html = container.innerHTML;
		}
	}
	return html;
}

//moved some init code to "window.onload" so we don't bother the server via signalr until everything is loaded
window.addEventListener("load", function () {

	// init SignalR connection
	window._connection = window._signalrConnection; //defined in utils.js

	var currentTicket = HDApp.TicketId;
	var username = HDApp.CurrentFullName;
	if (HDApp.IsTech) {
		_connection.on("updateViewingTechs", function (ticketId, users) {
			if (currentTicket != ticketId) return;
			//remove self
			var index = users.indexOf(username);
			if (index > -1)
				users.splice(index, 1);

			if (users.length > 0) {
				$(".techsViewingContainer").show();
				$(".techsViewingUsernames").html("<b>" + users.join(", ") + "</b> ");
			} else {
				$(".techsViewingContainer").hide();
			}
		});

		_connection.on("setActiveChat", function (ticketId, isActive) {
			if (isActive) {
				HDApp.InitialCommentText = ""; // entered chat - remove greeting and signature
				$(".activeChat").slideDown("fast");
				HDApp.IsActiveChat = true;
			}
			else {
				HDApp.InitialCommentText = greetingAndSignature; // exited chat bring greeting and signature back
				$(".activeChat").slideUp("fast");
				HDApp.IsActiveChat = false;
			}
		});
	}

	_signalrAfterConnect.then(function () {
		_connection.invoke("subscribeTicket", HDApp.TicketId, null, HDApp.IsTech);
	});

	//reconnect when connection dropped
	_connection.onreconnected(function (connectionId) {
		setTimeout(function () {
			if (_connection.state != signalR.HubConnectionState.Connected) return;

			_connection.invoke("subscribeTicket", HDApp.TicketId, null, HDApp.IsTech);
			var latestCommentId = $('div.commentDiv').first().data('commentid');
			if (latestCommentId)
				$.ajax(HDApp.Url + "Ticket/GetCommentsSince", { data: { ticketId: HDApp.TicketId, latestCommentId: latestCommentId, _connectionId: _connection.connection.connectionid } })
		}, 190000 + Math.random() * 20000); //after 3 minutes, backend won't return anything earlier anyway
	});

	_connection.on("newComment", function (commentJson) {
		if (!windowVisible && !document.title.startsWith("* ")) document.title = "* " + document.title; //add "* " to title so we tthere's new comment
		RenderAndAddNewComment(commentJson);
	});

	_connection.on("newSubscriber", function (userId, userName, isTech) { AddSubscriber(userId, userName, isTech, true); });

	_connection.on("updateTicket", function (statusId, categoryId, subject) {
		if (statusId !== HDApp.StatusId) StatusChanged(statusId, true);
		if (categoryId !== HDApp.CategoryId) CategoryChanged(categoryId);
		if (subject) $('#subject').text(subject);
	});

	_connection.on("removeSubscriber", function (userId) { RemoveSubscriber(userId, true); });

	_connection.on("updatedCustomField", RefreshCustomFields);

	_connection.on("removeAllSubscribers", function () { subscribersApp.Subscribers.splice(0); }); //access array via vue-object for reactitivy, also use splice for mutability (in-place change)

	_connection.on("startTyping", function (username) {
		if (username === HDApp.CurrentUserFullName) return;

		if (currentlyTypingUsernames.indexOf(username) === -1)
			currentlyTypingUsernames.push(username);

		updateCurrentlyTyping();

		$(".typingIndicator").slideDown("fast");
	});

	_connection.on("stopTyping", function (username) {
		var i = currentlyTypingUsernames.indexOf(username);
		if (i > -1)
			currentlyTypingUsernames.splice(i, 1);

		if (currentlyTypingUsernames.length === 0) {
			$(".typingIndicator").slideUp("fast");
		}
		else
			updateCurrentlyTyping();
	});

	//fixed realtime bar scroll
	//also sticky ticket header
	var $stickyHeader = $('#stickyHeader');
	var $window = $(window);
	toggleStickyHeader($stickyHeader, $window);
	$window.on("scroll", function (e) {
		toggleStickyHeader($stickyHeader, $window);
	});

	TicketMentions();
	DecodeAttImgs();
	HideInlineImgThunmbsAndAddLink(); //remove thumbnails for the images that are inline
	carouselReinit();
});

function toggleStickyHeader(header, window) {
	if (window.scrollTop() > 280)
		header.css('display', 'flex');
	else
		header.hide();
}

function editSubject(event) {
	event.stopPropagation();
	var el = $("#subject").addClass("contentEditable").get(0);
	el.contentEditable = true;
	el.focus();
	el.addEventListener('keydown', keyHandler);
	function keyHandler(event) {
		if (event.keyCode == 13 && this.innerText.trim()) {
			$.post(HDApp.Url + "Ticket/EditSubject", { ticketId: HDApp.TicketId, subject: this.innerText });
		}
		if (event.keyCode == 27 || event.keyCode == 13) {
			cancelEdit();
		}
	};
	document.addEventListener('click', function clickHandler(event) { //clicking outside should cancel editing too
		if (event.target == el) return;
		cancelEdit();
		this.removeEventListener('click', clickHandler);
	});
	function cancelEdit() {
		el.contentEditable = false;
		el.classList.remove('contentEditable');
		el.removeEventListener('keydown', keyHandler);
	}
}

function updateCurrentlyTyping() {
	$(".typingUsernames").html(currentlyTypingUsernames.join(', '));
	var verb = currentlyTypingUsernames.length > 1 ? "are" : "is";
	$(".typingVerb").text(verb);
}

function carouselReinit() {
	var uniqueImgUrls = []; // images for the image carousel

	var carouselHtml = "";
	// remove duplicates
	$('.imgLink').each(function () {
		var url = $(this).attr("href");
		url = normalizeFileUrlForCarousel(url);
		if (uniqueImgUrls.indexOf(url) == -1) {
			carouselHtml += "<a href='" + url + "'></a>";
			uniqueImgUrls.push(url);
		}
	});
	if (!carouselHtml) return;
	$("#imageCarousel").html(carouselHtml);
	var carousel = $("#imageCarousel a").simpleLightbox({ additionalHtml: "<a class='carouselOrigLink' href='javascript:void(0)' onclick='carouselOpenOrig()'>Open original <i class='fa fa-external-link'></i></a>", preloading: false });
	$('#imageCarousel a').on('error.simplelightbox', function (e) {
		return; //empty error handler to not proc sentry
	});

	// bind the click event. We need to show the modal on any of the image clicks
	$(".imgLink").unbind("click");
	$(".imgLink").click(function (e) {
		e.preventDefault();
		var url = normalizeFileUrlForCarousel($(this).attr("href"));
		carousel.open($("#imageCarousel a[href='" + url + "']"));
	});
}

function DecodeAttImgs($element) { //convert "src=attXXX" to "src=/File/Get/XXXX"
	$element = $element || $('.commentBody,#ticketBody');
	$element.find("img[src^='att']").each(function (i, el) {
		el.src = el.getAttribute("src").replace('att', HDApp.Url + "File/Get/");
	});
}

function TicketMentions($element) { //convert "#123213" and "<a data-mentioneduserid>" to links. inside $element (optional)
	var rx = /(^|\W)##(\d+)/g;
	$element = $element || $('.commentBody,#ticketBody');
	$element.find("*").contents().filter(function () { return this.nodeType === 3; }).each(function (i, el) { //find all text nodes
		if (el.nodeValue.indexOf("##") > -1) {
			var html = el.nodeValue.replace(rx, "$1<a href='" + HDApp.Url + "Ticket/$2'>##$2</a>");
			$(el).replaceWith(html);
		}
	});

	//now make user mentions link to user profiles
	HtmlSanitizer.AllowedAttributes['data-mentioneduserid'] = true;
	var mentions = $element.find("a[data-mentioneduserid]");
	mentions.attr("href", HDApp.Url + "User/View/" + mentions.data("mentioneduserid"));
}

function carouselOpenOrig() {
	window.open($(".sl-image img").attr("src"), '_blank');
}

function normalizeFileUrlForCarousel(url) {
	if (!url.lastIndexOf("http", 0) == 0)
		url = location.protocol + '//' + location.hostname + (location.port ? ':' + location.port : '') + url;

	return url;
}

function RenderAndAddNewComment(commentJson, highlight) {
	if (typeof highlight === 'undefined') highlight = true;

	//comment already rendered? (clash with websocket update)
	if ($("#tdComment" + commentJson.CommentID).length) return;

	//add info about subscribers for correct "spy" icon. also remove some properties for smaller JSON
	var dataObj = { model: commentJson, subscribers: HDApp.Subscribers.map(function (u) { return { UserID: u.UserID, Username: u.Username }; }) };

	$.ajax(HDApp.Url + "Ticket/RenderComment", {
		data: JSON.stringify(dataObj),
		contentType: "application/json",
		type: "POST",
		success: function (html) {
			//check again after http-request - comment already rendered? (clash with websocket update)
			if ($("#tdComment" + commentJson.CommentID).length) return;

			var comment = $(html);
			comment.addClass("fadeIn");
			comment.insertAfter($("#divNewComment"));
			if (highlight)
				$(".ticketComment", comment).addClass("highlight");

			
			HideInlineImgThunmbsAndAddLink();

			if (windowVisible)
				setTimeout(function () { $(".ticketComment", comment).removeClass("highlight"); }, 5000);

			carouselReinit(); // in case new image attachments were added

			fixColorsForDarkTheme();  // if dark theme is enabled fix the new comment contrast 

			// if currently in chat play a sound (not for system or own comments)
			if (HDApp.IsActiveChat && commentJson.UserID == HDApp.UserId && !commentJson.IsSystem) {
				document.getElementById("beep").play();
			}

			TicketMentions(comment);
			DecodeAttImgs(comment);
		}
	});
}

function ShowNewComment() {
	$('#txtNewComment').hide();
	//set cursor after the greeting tempplate

	$divNewComment = $('#divNewComment');
	$divNewComment.show();
	$divNewComment.addClass("fadeIn");
	FocusOnEditor();

	//if editor ouside scroll - scroll to it
	if($divNewComment[0].getBoundingClientRect().bottom > window.innerHeight){
		$('html, body').animate({
			scrollTop: $divNewComment.offset().top - window.innerHeight + $divNewComment[0].offsetHeight
		}, 1000);
	}
}

function FocusOnEditor() {
	try {
		if (wswgEditor.IsEditorVisible()) {
			SetCaretPositionAfterGreeting(wswgEditor.getEditorDoc());
			AutoResizeEditableIframe(wswgEditor.getEditorDoc());
		}
		else {
			$('#tbNewComment').focus().selectRange(greetingLength - 1, greetingLength - 1);
		}

	}
	catch (ex) { } //trycatch is for IE to suppress error
}

//this function moves not by character, but by element, including <br> and textnodes
function SetCaretPositionAfterGreeting(ifr) {
	ifr.focus();

	var greetingNode = document.getElementById("greetingend");
	
	var sel = window.getSelection();
	var range = (sel.rangeCount > 0 ? sel.getRangeAt(0) : document.createRange()); //rangeCount - FF workarounf

	if (greetingNode) {
		range.setStartAfter(greetingNode);
		range.setEndAfter(greetingNode);
	}
	else { //no greeting - put at the start (FF)
		range.selectNodeContents(ifr);
		range.collapse(true);
	}
	ifr.focus();
	sel.removeAllRanges();
	sel.addRange(range);
}

function HideNewComment() {
	removeCommentDraft();

	//reset comment to it's original state (greeting + sig)
	if (typeof wswgEditor !== 'undefined' && wswgEditor.IsEditorVisible())
		wswgEditor.SwitchEditor();

	$("#tbNewComment").text(HDApp.InitialCommentText).val(HDApp.InitialCommentText);
	if (typeof wswgEditor !== 'undefined')
		wswgEditor.SwitchEditor();

	$('#txtNewComment').show();
	$('#divNewComment').hide();

	$(window).off("beforeunload", UnloadConfirm);
}

function IsNewCommentEmpty() {
	return ($.trim($("#tbNewComment").val()) == "" && !FileUploadHelper.HasFilesToUpload());
}

function ShowHideNewSubscriber(show) {
	$('#divNewSubscriber').css ("display", show ? '' : 'none');
	$('#divNewSubscriberLink').css("display", show ? 'none' : '');
	if (show) $('#tbNewSubscriber').focus();
	else $('#tbNewSubscriber').val("");
}

function AddSubscriber(userId, userName, isTech, addToUiOnly) {
	ShowHideNewSubscriber(false);
	$("#emailValidationError").hide();

	if (userId != 0 && HDApp.Subscribers.filter(function (u) { return u.UserID == userId }).length) return; //already added and its not a "new" user

	if (!addToUiOnly) {
		if (userId == 0) { //not from the suggest box
			$.ajax({
				url: HDApp.Url + "Ticket/AddSubscriberByEmail",
				data: { email: userName, ticketId: HDApp.TicketId },
				method: "POST",
				async: false,
				success: function (data) {
					if (data && Object.hasOwn(data, "UserID"))
						userId = data.UserID;
				}
			});
		}
		else {
			$.post(HDApp.Url + "Ticket/AddSubscriber", { ticketId: HDApp.TicketId, userId: userId });
		}
	}

	if (userId == 0 && !HDApp.IsTech) return; //still 0 - get out

	HDApp.Subscribers.push({ UserID: parseInt(userId), Username: userName, FullName: userName, IsTech: isTech, Checked: true, SendEmail: true });
}

function RemoveSubscriber(userId, removeFromUiOnly) {
	for (var i = 0; i < HDApp.Subscribers.length; i++) {
		var subscriber = HDApp.Subscribers[i];
		if (subscriber.UserID == userId) {
			if (removeFromUiOnly || confirm('Are you sure to remove "' + subscriber.Username + '" from this ticket permanently?')) {
				HDApp.Subscribers.splice(i, 1); //remove from array
				if (!removeFromUiOnly && userId != 0) //not a "recently added" subscriber who's not in the DB
					$.post(HDApp.Url + "Ticket/RemoveSubscriber", { ticketId: HDApp.TicketId, userId: userId });
			}
			return;
		}
	}
}

function ShowSharePopop() {
	$.get(HDApp.Url + "Ticket/SharePopup/" + HDApp.TicketId, function (html) {
		$.modal(html);
	});
}

function UnloadConfirm() { return "You have unsaved changes."; }

function loadKBArticles() {
	var elem = $("#selKb");
	var dropdown = $(".dropdown-menu", elem);
	if (elem.data("loaded") == false) {
		$.post(HDApp.Url + "Ticket/GetKBArticlesList", function (data) {
			$(".kbIndicator", dropdown).hide();

			vueKb.KbCategories = data.Categories; //fill categories
			for (var i = 0; i < vueKb.KbCategories.length; i++) { //fill articles inside categories (stupid IE, no foreach)
				vueKb.KbCategories[i].Articles = data.Articles.filter(function (a) { return a.CategoryID == vueKb.KbCategories[i].CategoryID; });
			}

			//check if there are any suggested articles from bot
			var related = $('.relatedArticle');
			if (related.length > 0) {
				var fakeCategory = { CategoryID: 0, NameWithSection: _langStrings.SimilarArticles, Articles: [] };
				vueKb.KbCategories.unshift(fakeCategory); //"unshift" means "push at the beginning"
				$.each(related, function (i, article) {
					fakeCategory.Articles.push({ CategoryID: 0, ArticleId: $(article).data("id"), Subject: $(article).text() }); //push into vue object
				});
			}
			$('#kbFilter').focus();
			elem.data("loaded", true);
		});
	}
}

function PasteKBLink(id, subj) {
	var txt = "<a href='" + HDApp.Url + "KB/View/" + id + "'>" + subj + "</a>";
	ShowNewComment(); // show and focus on editor
	wswgEditor.InsertText(txt);
}

function AddComment(showDueTooltip) {
	$("#ajaxLoader").show();

	if (FileUploadHelper.uploadInProgress()) {
		setTimeout(function () { AddComment(showDueTooltip); }, 50);
		return;
	}

	$("#btnSubmitForm").click(); //instead of calling "form.submit()" we call "click()" on a hidden button, because sometimes "submit()" glithces :(((

	//showing due-date popup tooltip
	if(HDApp.IsTech) {
		if(showDueTooltip==true && $.cookie('dueDateShown')!='true' && $.trim($('#lblDueDate').html())=="" ) {
			$.cookie('dueDateShown', 'true');
			$('#dueTip').show();//showing popup
			$("html").bind('click', function(){$('#dueTip').hide();});
		}
	}

	return false;
}

function DelComment(commentId) {
	if(confirm(_langStrings.AreYouSure)) {
		$.post(HDApp.Url + "Ticket/DeleteComment", { commentId: commentId, ticketId: HDApp.TicketId }, function(data) {
			$('#tdComment'+commentId).remove(); //deleting comment TR element
		});
	}
}

function CollapseExpandComment(event) {
	if (!event.ctrlKey) {
		$(event.currentTarget).closest('.ticketComment').find('.commentBody').slideToggle('fast');
		$(event.currentTarget).find('i').toggleClass('fa-compress').toggleClass('fa-expand');
	}
	else {
		$('.commentBody').slideToggle('fast');
		var $iminus = $('i.fa-compress, i.fa-expand');
		$iminus.toggleClass('fa-compress').toggleClass('fa-expand');
	}
}

function AddCommentSuccess(data) {
	$(window).off("beforeunload", UnloadConfirm);
	isUnloadBound = false;
	if ($("#inptCommentAndResolve").val() == "true") {
		closeSuccess(data.StatusID == 3);
	}
	
	$(".error").hide();

	if (data) {
		RenderAndAddNewComment(data, false);
		if (data.Body.indexOf("data-mentioneduserid")) { //someone was mentioned? add them to subs
			$(data.Body).filter("a[data-mentioneduserid]").each(function () {
				var $mention = $(this);
				AddSubscriber($mention.data("mentioneduserid"), $mention.text().substring(1), true, true);
			});
		}
	}
	else { //data empty, probably dupe
		var defaultErrorText = $('#divCommentError').text();
		$('#divCommentError').text('Whoops, you already said that').show();
		setTimeout(function () { $('#divCommentError').fadeOut('slow', function () { $('#divCommentError').text(defaultErrorText); }); }, 3000);
	}

	if (data.StatusID != HDApp.StatusId) { //re-render toolbar only if status has changed
		HDApp.StatusId = data.StatusID;
		RefreshToolbar();
	}

	HideNewComment();
	AddSubscriber(HDApp.CurrentUserId, HDApp.CurrentUserFullName, true); //add curruser subscriber to UI only
	try{
		if(!$("#lnkAssignedTo").data("userid"))
			RefreshAssignee();
	} catch(e) { }
	$("#ajaxLoader").hide();
	$('.pickedfiles').empty();
	FileUploadHelper.reinit();
}

function AddCommentAndResolve()
{
	$("#inptCommentAndResolve").val("true");

	return AddComment(false);
}

function EditComment(commentId, issueId) {
	var url = HDApp.Url + "Ticket/EditComment/" + commentId + "?ticketId=" + issueId;
	window.location.assign(url);
}

function CommentSubmitFailure() {
	$("#ajaxLoader").hide();
	$("#htmlBtnAdd, #htmlBtnAddAndResolve").removeAttr("disabled", "disabled");
	$("#divCommentError").hide().fadeIn(); //hide first to create a blinking effect, if it already was shown
}

$(function () {
	initNextPrev();
});

function initNextPrev() {
	if(sessionStorage && sessionStorage.getItem("ticketIds")) {
		var ticketIds = JSON.parse(sessionStorage.getItem("ticketIds"));
		if(ticketIds.length<1) return;
		var curticketindex = ticketIds.indexOf(parseInt($('#h2TicketId').text().substr(1)));
		if(curticketindex==-1) return;
		if(curticketindex < ticketIds.length) //not the last element
			$('#btnNext').show().attr("href", ticketIds[curticketindex+1]);
		if(curticketindex > 0) //not the first
			$('#btnPrev').show().attr("href", ticketIds[curticketindex-1]);
	}
}

function ToggleEditor(elem, show, dontSelectText)
{
	//for this to work editor controls should be wrapped in the div with class editor, toggling button should have class editButton and be outside of that div
	//info spans should have class info
	var elem = $(elem);
	var td = elem.parents("td"); //getting parent td
	if(show)
	{
		$(".editButton", td).hide();
		$(".info", td).hide();
		$(".editor", td).fadeIn();
		$(".editor input", td).focus();
		if(!dontSelectText)
			$(".editor input", td).select();
	}
	else{
		$(".editButton", td).show();
		$(".info", td).show();
		$(".editor", td).hide();
	}
}

function AddTag(tagId, tagName){
	$.post(HDApp.Url + "Ticket/AddTag", { ticketId: HDApp.TicketId, tagId: tagId, tagName: tagName }, function (data) {
		if (tagId == 0) { //update the tag box with the new TagID
			var newval = $("#tbTags").val().replace(tagName + "|0", tagName + "|" + data.tagId);
			$('#tbTags').val(newval);
			$('#tbTags_tagsinput a.remove').last().off('click').on('click', function () { return $('#tbTags').removeTag(escape(tagName + "|" + data.tagId)); }); //update the "remove" click too
		}
	});
}
function RemoveTag(tagId){
	$.post(HDApp.Url + "Ticket/RemoveTag", { ticketId: HDApp.TicketId, tagId: tagId });
}
function AddSecondaryAssignee(tagId, tagName){
	$.post(HDApp.Url + "Ticket/AddSecondaryAssignee", { ticketId: HDApp.TicketId, tagId: tagId, tagName: tagName });
	AddSubscriber(tagId, tagName, true);
}
function RemoveSecondaryAssignee(tagId) {
	if (!tagId) return; //can be called with empty "id" on backspace
	$.post(HDApp.Url + "Ticket/RemoveSecondaryAssignee", { ticketId: HDApp.TicketId, tagId: tagId });
	if (!$('#tbAssignees').val()) //no one left
	{
		$('#trMultiAssign').hide();
		$('#divAddSecondaryAssignees').show();
	}
}

function AddAsset(assetId){
	$.post(HDApp.Url + "Ticket/AddRelatedAsset", { ticketId: HDApp.TicketId, tagId: assetId });
}
function RemoveAsset(assetId){
	$.post(HDApp.Url + "Ticket/RemoveRelatedAsset", { ticketId: HDApp.TicketId, tagId: assetId });
}

var _stopwatch;
var _autoSecondsAdded = 0;
function StartTimeSpentTimer() {
	if (HDApp.AutoTimerEnabledGlobally && (!HDApp.AutoTimerOnlyWhenAssigned || $("#lnkAssignedTo").data("userid"))) {
		var elem = document.getElementById('lblTimeSpent');
		if (!elem) return; //elem does not exist, probably not tech in this cat
		var existingTime = elem.textContent;
		var timeArr = existingTime.split(":");
		var existingSeconds = 0;
		existingSeconds += parseInt(timeArr[2]);
		existingSeconds += parseInt(timeArr[1]) * 60;
		existingSeconds += parseInt(timeArr[0]) * 3600;

		var lastUpdateTime = Date.now();
		if (_stopwatch) clearInterval(_stopwatch);
		_stopwatch = setInterval(updateTime, 1000);

		if (window.visHandler) document.removeEventListener('visibilitychange', window.visHandler); //to prevent double binding
		window.visHandler = function() {
			if (document.visibilityState === 'hidden') {
				lastUpdateTime = Date.now();
				clearInterval(_stopwatch);
			} else {
				let secondsPassed = Math.floor((Date.now() - lastUpdateTime) / 1000);
				existingSeconds += secondsPassed;
				_autoSecondsAdded += secondsPassed;
				lastUpdateTime = Date.now();
				if (_stopwatch) clearInterval(_stopwatch);
				_stopwatch = setInterval(updateTime, 1000);
			}
		};
		document.addEventListener('visibilitychange', window.visHandler);

		function updateTime() {
			_autoSecondsAdded++;
			existingSeconds++;
			var h = Math.floor(existingSeconds / 3600);
			var m = Math.floor(existingSeconds % 3600 / 60);
			var s = Math.floor(existingSeconds % 3600 % 60);
			elem.textContent = Utils.padNumber(h, 2) + ":" + Utils.padNumber(m, 2) + ":" + Utils.padNumber(s, 2);
		}

		$(window).on("beforeunload", AutoSaveTimeSpent);
	}
}


function ShowOriginDetails() {
	if ($.trim($("#divOrigin").html()) == '') {
		var $lastComment = $('div.commentDiv').last();
		$('#divOrigin').html($lastComment.find('.commentBody').html()
			+ ($lastComment.find(".emailHeaders").length ? $lastComment.find(".emailHeaders").html() : ""));
		if ($("#divOrigin").data("originalemailfileid")) { //has "original email" file
			$("#divOrigin").append("<br><a href='" + HDApp.Url + "File/EmlViewer/" + $("#divOrigin").data("originalemailfileid") + "' target='_blank'>show original email</a>");
		}
	}

	$('#divOrigin').slideToggle()
}

function AutoSaveTimeSpent() {
	if (_stopwatch) {
		if (navigator.sendBeacon) { navigator.sendBeacon(HDApp.Url + "Ticket/AddTime?ticketId=" + HDApp.TicketId + "&seconds=" + _autoSecondsAdded, ""); }
		StopTimeSpentTimer();
	}
}

if (HDApp.StatusId != 3 && HDApp.IsTech && HDApp.AutoTimerEnabledOnLoad) {
	StartTimeSpentTimer(); //launch the autotimer
}
	
function StopTimeSpentTimer() {
	if(typeof _stopwatch !== 'undefined') {clearInterval(_stopwatch); _stopwatch=false;}
	$(window).off("beforeunload", AutoSaveTimeSpent);
}

function SaveTime() {
	//StopTimeSpentTimer();
	$.ajax({ type: "POST", url: HDApp.Url + "Ticket/SaveTime?ticketId=" + HDApp.TicketId + "&time=" + $("#txtTimeSpent").val(), async: false});
	$('#lblTimeSpent').text($('#txtTimeSpent').val());
	//StartTimeSpentTimer();
}

function GetTechs(categoryID) {
	var sel = $('#selTechId');
	if(sel.has("option").length > 0) return; //already filled
	$.post(HDApp.Url + "Ticket/GetTechsForCategory?categoryId=" + categoryID, function (data){
		sel.append('<option value="0"></option>');
		for (var i=0; i<data.length; i++) {
			sel.append('<option value="' + data[i].UserID + '" ' + (data[i].OutOfOffice ? "title='out of office'" : "") + '>' + data[i].FullNameAndLogin + ' (' + data[i].TicketsAssigned + ')' + (data[i].OutOfOffice ? " 🏝️" : "") + '</option>');
		}
		sel.val($('#lnkAssignedTo').data("userid"));
	});
}

function GetCategories(spanId = "#changeCategory") {
	$.get(HDApp.Url + "Ticket/GetCategoriesHtmlSelect?categoryId=" + HDApp.CategoryId, function (data) {
		$(spanId).html(data);
	});
}

function ClearDueDate() {
	$("#txDueDate").val("");
}

function SaveCategory() {
	if ($('#selCategory').length) {
		if (document.querySelector('div[id^="spanFldValue"]') != null) //custom fields exist on page?
		{
			$.ajax({
				url: HDApp.Url + "Ticket/LostFieldsCheck?fromCategoryId=" + HDApp.CategoryId + "&toCategoryId=" + $('#selCategory').val(),
				success: function (data) {
					if (data == "True") { //some fields will be lost
						if (confirm("Looks like some custom fields are missing in that new category, the data will be lost. Are you sure?"))
							ChangeCategory();
					}
					else
						ChangeCategory();
				}
			});
		}
		else
			ChangeCategory();

		function ChangeCategory() {
			$.post(HDApp.Url + 'Ticket/ChangeCategory', { ticketId: HDApp.TicketId, categoryId: $('#selCategory').val() }, function () {
				CategoryChanged($('#selCategory').val());
			});
		}
	}
}

function CategoryChanged(categoryId) {
	if (categoryId == HDApp.CategoryId) return;
	HDApp.CategoryId = categoryId;
	RefreshCustomFields();
	RefreshToolbar();
	$('#selCategory').val(categoryId);
	$('#selTechId').empty();
	if($('#selCategory option').length && $(`#selCategory option[val=${categoryId}]`).length) //we already filled category dropdown (and this category is in it), save API call
		$('#spanCatName').text($('#selCategory option:selected').text());
	else //get name from server
		$.post(HDApp.Url + "Ticket/GetCategoryName", { categoryId: categoryId }, function (data) {
			$('#spanCatName').text(data.category);
		});
	ToggleEditor($('#lnkAssignedTo')[0], false); //close "assign" editor if its open, so its refreshed next time
}

function RefreshCustomFields() {
	$.post(HDApp.Url + "Ticket/RefreshCustomFields", { ticketId: HDApp.TicketId, categoryId: HDApp.CategoryId },
		function (data) {
			$('#TicketCustomFields').html(data);
		});
}

function SaveDueDate() {
	$.post(HDApp.Url + "Ticket/SaveDueDate", { ticketId: HDApp.TicketId, date: $("#txDueDate").val() },
	function (data) {
		if (data.error) {
			alert(data.error);
		}
		else {
			$("#txDueDate").val(data.date);
			$("#lblDueDate").html(Utils.formatDateLocale(data.date)); //show text in current culture format, not in "yyyy-MM-dd"
		}
	});
}

function SaveStartDate() {
	$.post(HDApp.Url + "Ticket/SaveStartDate", { ticketId: HDApp.TicketId, date: $("#txStartDate").val() },
		function (data) {
			if (data.error) {
				alert(data.error);
			}
			else {
				$("#txStartDate").val(data.date);
				$("#lblStartDate").html(Utils.formatDateLocale(data.date)); //show text in current culture format, not in "yyyy-MM-dd"
			}
		});
}

function SaveTicketDate() {
	$.post(HDApp.Url + "Ticket/SaveTicketDate", { ticketId: HDApp.TicketId, date: $("#txTicketDate").val() },
	function (data) {
		if (data.error) {
			alert(data.error);
		}
		else {
			$("#txTicketDate").val(data.date);
			$("#lblTicketDate").html(Utils.formatDateLocale(data.date)); //show text in current culture format, not in "yyyy-MM-dd"
		}
	});
}

function SaveCloseDate() {
	$.post(HDApp.Url + "Ticket/SaveCloseDate", { ticketId: HDApp.TicketId, date: $("#txCloseDate").val() },
		function (data) {
			if (data.error) {
				alert(data.error);
			}
			else {
				$("#txCloseDate").val(data.date);
				$("#lblCloseDate").html(Utils.formatDateLocale(data.date)); //show text in current culture format, not in "yyyy-MM-dd"
			}
		});
	if (HDApp.StatusId != 3 && confirm("Would you also like to close the ticket?"))
		$("#btnClose")[0].click();
}


function SaveAssignee() {
	var assigneeId = $("#selTechId").val();
	if (!assigneeId || assigneeId == 0) {
		RemoveAssignee();
		$('#divAddSecondaryAssignees').hide();
		$('#trMultiAssign').hide();
		return;
	}

	$.post(HDApp.Url + "Ticket/SaveAssignee", { ticketId: HDApp.TicketId, userId: assigneeId },
		function (data) {
			ShowAssignee(data);
			AddSubscriber(assigneeId, data.username, true);
			$('#lnkAssignedTo').attr("data-userid", assigneeId);
			if ($('#trMultiAssign').length && !$('#tbAssignees').val()) //if <tr> exists (multiassign is enabled) and no secodanry assignees yet
				$('#divAddSecondaryAssignees').show();
		});
}

function ShowAssignee(jsonData) {
	$("#lnkAssignedTo").html(jsonData.fullName);
	$("#lnkAssignedTo").attr("href", HDApp.Url + "User/View/" + jsonData.userId);
	$("#lnkAssignedTo").data("userid", jsonData.userId);
	$("#selTechId").val(jsonData.userId);
	//restart time-spent timer
	StopTimeSpentTimer();
	if (HDApp.AutoTimerEnabledGlobally)
		StartTimeSpentTimer();
}

function RefreshAssignee() {
	$.post(HDApp.Url + "Ticket/GetAssignee", { ticketId: HDApp.TicketId },
	function (data) {
		ShowAssignee(data);
	});
}

function RemoveAssignee() {
	$.post(HDApp.Url + "Ticket/RemoveAssignee", { ticketId: HDApp.TicketId },
	function (data) {
		ShowAssignee(data);
	});
}

function SaveSubmitter() {
	var submitterId = $("#txtUsers").val();
	if (!submitterId) {
		alert("No user specified. Please select an existing user from the suggestions dropdown.");
		return;
	}
	$.post(HDApp.Url + "Ticket/SaveSubmitter", { ticketId: HDApp.TicketId, userId: submitterId },
		function (data) {
			$("#lnkFrom").html(data.fullName);
			$("#lnkFrom").attr("href", HDApp.Url + "User/View/" + data.userId);
			$("#lnkFrom").attr("data-userid", data.userId);
			$("#lnkFrom").attr("data-username", data.username);
			if (data.companyId) {
				$("#lnkFromCompany").html(data.companyName);
				$("#lnkFromCompany").attr("href", HDApp.Url + "User/Company/" + data.companyId);
			}
			else {
				$("#lnkFromCompany").html("");
			}
			AddSubscriber(submitterId, data.fullName, false);
		});
}

//assigning enter key to submit changes
$(function () {
	$(".issueDetails td input[type='text']").keypress(function (event) {
		if (event.which || event.keyCode) {
			if ((event.which == 13) || (event.keyCode == 13)) {
				$("button", $(this).parents(".editor")).click(); return false;
			}
		} else { return true };
	});
});

function RemoveBadge(ticketID) {
	$.get(HDApp.Url + "Ticket/RemoveBadge", { ticketId: ticketID }, function (data) {
		$(".fortech-badge, .cust-badge").fadeOut();
	});
}

//set #toolbar div to float-right if there's no "action-buttons" (non-tech user), looks prettier
$(function() {
	if($.trim($("#status").html())=='')
		$("#toolbar").css("float", "right");
	if ($('#cbSubs' + HDApp.CurrentUserId).length != 0) $('#lnkSubscribe').text(_langStrings.Unsubscribe);
});

$(InitToolbar());

//too many custom statuses - hide them under dropdown --%>
function InitToolbar() {
	var buttons = $("#toolbar li.customstatus");

	if (buttons.length > 3 && $(".moreBtnToolbar").length == 0) {
		buttons.detach();
		buttons.children("input").attr("class", "transparentbutton").attr("style", "");
		$("#toolbar ul#status").append('<li><div class="customStatusesPopup"><button type="button" class="moreBtnToolbar">' + _langStrings.More + ' &rsaquo;</button><ul class="outerroundedbox" id="statusesDdl" style="padding:2px"></ul></div></li>');
		buttons.appendTo($("#toolbar ul#status ul"));

		$("<style type='text/css'> div.customStatusesPopup ul{ display:none } .moreBtnToolbar:focus+ul, div.customStatusesPopup:hover ul{ display:block } </style>").appendTo("head"); //show dropdown on hover and btn focus (via CSS for accessibility)
	}
}

function SubscribeUnsubscribe(lnk) {
	var subscribeStr = lnk.getAttribute("data-subscribe");
	var unsubscribeStr = lnk.getAttribute("data-unsubscribe");
	if (lnk.text == subscribeStr) {
		AddSubscriber(HDApp.CurrentUserId, HDApp.CurrentUserFullName, HDApp.IsTech); //declared in _TicketComments
		lnk.text = unsubscribeStr;
	}
	else if (lnk.text == unsubscribeStr) {
		RemoveSubscriber(HDApp.CurrentUserId); //declared in _TicketComments
		lnk.text = subscribeStr;
	}
}

//callback from ajax-toolbar OR via signalr "updateTicket"
function StatusChanged(newStatusId, refreshtoolbarfromserver) {
	if (newStatusId == -1) { document.location = HDApp.Url; return; } //ticket was deleted, get out

	HDApp.StatusId = newStatusId;
	if (newStatusId != 3) $('#htmlBtnAddAndResolve').show(); //restore reply&close btn on reopen
	if (!refreshtoolbarfromserver) //when called from toolbar after ajax-success - it's already rendered, just need a reinit
		InitToolbar();
	else
		RefreshToolbar();
	$.post(HDApp.Url + "Ticket/GetStatusInfo", { statusId: newStatusId }, function (status) {
		$("#ticketStatus").html(status.Name);
		if (status.StopTimeSpent) {
			AutoSaveTimeSpent();
			StopTimeSpentTimer();
		}
		else if (HDApp.AutoTimerEnabledGlobally) {
			StartTimeSpentTimer();
		}
	});
}
	
//this one called from other views
function RefreshToolbar() {
	$.post(HDApp.Url + "Ticket/RefreshToolbar", { ticketId: HDApp.TicketId }, function (data) {
		var surrounding = $("<div></div>"); //wrap in a div, so jquery selector finds root element
		$(data).appendTo(surrounding);
		var newHtml = surrounding.find('#toolbar').html();
		$("#toolbar").empty().html(newHtml);
		InitToolbar();
	});
}
	
function DeleteClick(delPermanently) //delete ticket
{
	if (confirm('Are you sure you want to delete the ticket?')) {
		stopSignalrConnection();
		$.post(HDApp.Url + "Ticket/DeleteTicket", { ticketId: HDApp.TicketId }, function () {
			window.location.href = delPermanently ? HDApp.Url + "/Reporting/Deleted" : HDApp.Url;
		});
	}
	else {
		return false;
	}
}

function MarkSpam() //delete ticket
{
	if (confirm('Are you sure you want to mark the ticket as spam? It will block all future emails from this user!\n(deletes the ticket and disables the user-account')) {
		stopSignalrConnection();
		$.post(HDApp.Url + "Ticket/MarkSpam", { ticketId: HDApp.TicketId }, function (data) {
			if (data.redirect) //the url where to redirect to from controller
			{
				window.location.href = data.redirect;
			}
			if (data.error) {
				alert(data.error);
			}
		});
	}
	else {
		return false;
	}
}

function ShareTicket() {
	$.post(HDApp.Url + "Ticket/Share/" + HDApp.TicketId,
		function (data) {
			$('#tbShareLink').val(HDApp.Url + "Ticket/ViewShared/" + HDApp.TicketId + "?h=" + data);
			$("#shareLinkContainer").show();
			$('#shareConfirmation').hide();
		});
}

function DupClick(onClickFunction, prompt, newTicketLink) {
	if ($('#divTicketsList').text().trim()=="") { //query server only if empty
		$.get(HDApp.Url + "Ticket/GetTicketsFromUser", { ticketid: HDApp.TicketId, userid: HDApp.UserId, companyId: $('#lnkFromCompany').data("userid"), newTicketLink: newTicketLink },
			function (data) {
				$('#divTicketsList').html(data).modal();
				$('#thDupPrompt').html(prompt);
			});
	}
	else { //otherwise just set up newTicketButton
		if (newTicketLink)
			$("#btnNewTicketsPopup").show().attr("href", newTicketLink);
		else
			$("#btnNewTicketsPopup").hide();
		$('#divTicketsList').modal();
		$('#thDupPrompt').html(prompt);
	}

	window.dupClickRow = onClickFunction;

	window.dupClickById = function() {
		var ticketId = $("#dupTicketId").val();
		if (!ticketId || ((+ticketId) | 0) != ticketId) { //int32 check https://stackoverflow.com/a/26505572/56621
			$("#dupTicketId").addClass('error');
			return;
		}

		$.get(HDApp.Url + "Ticket/CheckTicketExists", { id: ticketId }, function (data) {
			if (data === "True") { //ticket exists
				onClickFunction(ticketId);
			} else {
				$("#dupTicketId").addClass('error');
				alert("Ticket with that number doesn't exist");
			}
		});
	}
}

function CloseDuplicate(primaryId) {
	if (!confirm("Are you sure? There is no way to undo this action."))
		return;
	$.get(HDApp.Url + "Ticket/CloseDuplicate", { duplicateId: HDApp.TicketId, primaryId: primaryId }, function (data) {
		$.modal.close();
		location.reload(false);
	})
}

function ConvertToReply(primaryId) {
	if (!confirm("Only the ticket text will be converted, existing replies will be lost.\n\nAre you sure? There is no way to undo this action."))
		return;
	$.get(HDApp.Url + "Ticket/ConvertToComment", { ticketId: HDApp.TicketId, ticketToId: primaryId }, function (data) {
		$.modal.close();
		location.href = HDApp.Url + "Ticket/" + primaryId;
	})
}

function MoveComment(ticketId, commentId) {
	if (!confirm("Are you sure? There is no way to undo this action."))
		return;
	$.get(HDApp.Url + "Ticket/MoveComment", { ticketId: ticketId, commentId: commentId }, function (data) {
		$.modal.close();
		location.href = HDApp.Url + "Ticket/" + ticketId;
	})
}

function Merge(primaryId) {
	if (!confirm("Are you sure? There is no way to undo this action."))
		return;
	$.get(HDApp.Url + "Ticket/Merge", { duplicateId: HDApp.TicketId, primaryId: primaryId }, function (data) {
		$.modal.close();
		location.href = HDApp.Url + "Ticket/" + primaryId;
	})
}

function Link(primaryId) {
	$.get(HDApp.Url + "Ticket/Link", { duplicateId: HDApp.TicketId, primaryId: primaryId }, function (data) {
		$.modal.close();
		location.reload(false);
	})
}

function MakeSubticket(parentId) {
	$.get(HDApp.Url + "Ticket/AddSubTicket", { parentId: parentId, childId: HDApp.TicketId }, function (data) {
		$.modal.close();
		location.reload(false);
	})
}

function MakeParent(childId) {
	$.get(HDApp.Url + "Ticket/AddSubTicket", { parentId: HDApp.TicketId, childId: childId }, function (data) {
		$.modal.close();
		location.reload(false);
	})
}

function closeSuccess(data) {
	if (data == true) {
		document.location = HDApp.Url;
	}
	else
		alert(_langStrings.TicketCannotBeClosedCF);
}

//load similar articles from KB
$(function () {
	if (!HDApp.IsSmartphoneOrTablet) {
		$.ajax({
			type: "POST",
			url: HDApp.Url + "Tickets/GetSimilarFromKB?ticketId=" + HDApp.TicketId,
			data: { "subj" : escape($("#subject").text()) },
			dataType: "json",
			success: function (msg) {
				if (!msg || msg.length === 0) { return; }

				// if the ticket is new we create a new fancy comment from the bot, 
				// otherwise we put suggestions in the sidebar as usual
				if (HDApp.StatusId == 1 && HDApp.BotEnabled) {
					var body = "<!--html-->I've found some articles that may help the customer:\n\n";
					$.each(msg, function (k, v) {
						body += "<a target='_blank' class='relatedArticle' data-id='" + v.ArticleId + "' href='" + HDApp.Url + "KB/View/" + v.ArticleId + "'>" + v.Subject;
						if (v.ForTechsOnly == true)
							body += "<span class='badge fortech-badge' title='this article is visible to technicians only'>for tech only</span>"
						body += "</a>";
						body += "&nbsp;<a title='Add a link to this article to your reply' href='javascript:void(0)' onclick='PasteKBLink(\"" + v.ArticleId + "\", \"" + v.Subject.replace(/['"]+/g, '') + "\")'><i class='fa fa-share'></i></a>\n";
					});
					body += "\nIf you think any of these articles are helpful click the arrow next to the article name to add it to your reply.\n\n"
					body += "<div class='grey'>I'm a bot. Replies like this show up in brand new, unanswered tickets. They are visible to technicians only and are not saved in the reply history." + (HDApp.IsAdmin ? " You can disable the bot in <a target='_blank' href='" + HDApp.Url + "Admin/GeneralSettings#botSetting'>KB settings</a>." : "") + "</div>"

					var commentJson = {};
					commentJson.Attachments = [];
					commentJson.Body = body;
					commentJson.CommentDate = HDApp.CurrentInstanceTime;
					commentJson.CommentID = 0;
					commentJson.Email = "bot@jitbit";
					commentJson.FirstName = "Jitbit";
					commentJson.ForTechsOnly = true;
					commentJson.IsSystem = false;
					commentJson.IssueID = HDApp.TicketId;
					commentJson.LastName = "Bot";
					commentJson.UserID = -1;
					commentJson.UserName = "jitbit_bot";

					RenderAndAddNewComment(commentJson, true);
				} else {
					var html = "<tbody>";
					$.each(msg, function (k, v) {
						html += "<tr><td><a class='relatedArticle' data-id='" + v.ArticleId + "' href='" + HDApp.Url + "KB/View/" + v.ArticleId + "'>" + v.Subject;
						if (v.ForTechsOnly)
							html += " <span class='badge fortech-badge' title='this article is visible to technicians only'>for tech only</span>"
						html += "</a></td></tr>";
					});
					html += "</tbody>"
					$(".similarArticles").append(html);
					$(".similarArticles").fadeIn();
				}
			}
		});
	}

	fixColorsForDarkTheme();
});

function fixColorsForDarkTheme() {
	//remove low contrast elements if we're in dark mode
	if ($("link[href*='_dark']").length) { //are we in dark mode?
		//remove color that is "too dark"
		ColorTool.removeDisallowedColorStyles("#ticketBody [style*='color'], #ticketBody font[color], .commentBody [style*='color'], .commentBody font[color]", 70, 256);
	}
	else { //we're in light mode
		//remove color that is "too bright"
		ColorTool.removeDisallowedColorStyles("#ticketBody [style*='color'], #ticketBody font[color], .commentBody [style*='color'], .commentBody font[color]", 0, 200);
		// fix very dark backgrounds as well
		ColorTool.removeDisallowedColorStyles("#ticketBody [style*='color'], #ticketBody font[color], .commentBody [style*='color'], .commentBody font[color]", 40, 255, true);
	}
}

function ResendComment(btnElement) {
	var $commentTd = $(btnElement).closest('.ticketComment');
	var commentHtml = $commentTd.find('.commentBody span').html();

	//attachments
	$commentTd.find("a.attachments").map(function () {
		FileUploadHelper.addExistingFile(this.id.replace("lnkFile", ""), this.title);
		return;
	});

	wswgEditor.getEditorDoc().innerHTML = commentHtml;
	ShowNewComment();
	$('#divNewComment')[0].scrollIntoView();
}

function ReattachFile(fileId, fileName) {
	FileUploadHelper.addExistingFile(fileId, fileName);
	ShowNewComment();
	$('#divNewComment')[0].scrollIntoView();
}

function disableBot() {
	$.cookie('disableBot', true, { expires: 365 });
}

// hotkeys and keyboard navigation for kb and canned responses
document.addEventListener("keydown", function cannedHotKeys(e) {
	var crShown = document.getElementById("selTemplates").classList.contains('open');
	var kbShown = document.getElementById("selKb")?.classList.contains('open'); //KB can be disabled, so we add "?."

	// dropdown is closed
	if (!(crShown || kbShown)) {
		return true;
	}

	// if we are here one of the dropdowns is visible. Which one?
	// kb or canned responses?
	var mainSelector = crShown ? "#selTemplates" : "#selKb";

	switch (e.key) {
		case 'ArrowDown':
			moveSelectedCannedResponse(kbShown);
			break;
		case 'ArrowUp':
			moveSelectedCannedResponse(kbShown, true);
			break;
		case 'Enter':
			var selectedTemplate = $("li.cResponse.selected");
			if (selectedTemplate.length) {
				templateId = selectedTemplate.data('template-id');
				$(mainSelector).removeClass('open');
				if (crShown)
					InsertTemplateExternal(templateId);
				else
					pasteKbText(templateId);
			}
			break;
		case 'Escape':
			$(mainSelector).removeClass('open');
			FocusOnEditor();
			break;
		default:
			return true;
	}
	e.preventDefault();
	return false;
});

function moveSelectedCannedResponse(moveKb = false, moveUp = false) {
	var selector = moveKb ? ".kbArticleList" : ".cannedResponseList";
	var responses = $(selector + " li.cResponse");
	var selectedIndex = responses.index($(selector + " .selected"));
	var selectedEl = null;
	if (selectedIndex === -1) { // none selected - select first
		selectedEl = responses[0];
	}
	else { // move selection to the next li
		// is there anywhere to move?
		haveSpaceToMove = false;
		if (moveUp)
			haveSpaceToMove = selectedIndex > 0;
		else
			haveSpaceToMove = selectedIndex < responses.length - 1;

		if (haveSpaceToMove) {
			var nextIndex = moveUp ? selectedIndex - 1 : selectedIndex + 1;
			selectedEl = responses[nextIndex];
			responses[selectedIndex].classList.remove("selected");
		}
	}
	if (selectedEl != null) {
		selectedEl.classList.add('selected');
		// is it hidden in a section? show it just in case
		$(selectedEl).parent('ul').show();
	}
}

// integrations 
function generateIntegrationIssueDetails(container, issue) {
	if (!issue.id) // there was an error getting the issue details
		issue.subject = "Error getting issue details";
	
	var html = generateIntegrationIssueDetailsHtml(issue);

	var issueDetails = container.querySelector(".integrationIssueDetails");
	issueDetails.innerHTML = html;

	issueDetails.style.display = "flex";
}

function generateIntegrationIssueDetailsHtml(issue) {
	var template = document.querySelector("#integrations-issue-template");
	var html = template.innerHTML;
	html = html.replace("{{ id }}", issue.id || "");
	html = html.replace("{{ url }}", issue.url);
	html = html.replace("{{ subject }}", issue.subject);
	html = html.replace("{{ submitterName }}", issue.submitterName || "");
	html = html.replace("{{ submitterAvatar }}", issue.submitterAvatar || "https://cdn.jitbit.com/helpdesk/images/batman.png");
	html = html.replace("{{ statusName }}", issue.statusName || "");
	html = html.replace("{{ issueDate }}", new Date(issue.issueDate).toLocaleString());
	html = html.replace("{{ unlinkUrl }}", issue.unlinkUrl);
	return html;
}

function openGPTModal(showCustomPrompt = false) {
	reinitGPTModal();
	$("#gptPopup").modal();
	if (showCustomPrompt) {
		$('#gptCustomPromptButtons').show();
		$("#gptPopupText").attr('placeholder', 'Simply write what you\'d like GPT to do here');
		$("#gptPopupOverlay").hide();
	}
}

function reinitGPTModal() {
	$("#gptPopupText").val('');
	$("#gptPopupOverlay").show();
	$("#gptCommandBtns").show();
	$("#gptPopupOverlayIndicator").hide();
	$("#gptInsertBtns").hide();
	$("#gptCustomPromptButtons").hide();
	$("#gptPopupText").attr('placeholder', '');
}

function generateGPTResponse(command = 'response') {
	$("#gptCommandBtns").hide();
	$("#gptPopupOverlay").show();
	$("#gptPopupOverlayIndicator").show();
	var tooLongTimeOut = setTimeout(function () { $("#gptTooLongText").show(); }, 5000);
	var body = $("div#body").html();
	var subj = $("#subject").text();

	if (command === 'improve') {
		wswgEditor.doCheck();
		body = document.getElementById("tbNewComment").value;
	}
	else if (command === 'custom') {
		body = $("#gptPopupText").val() + $("div#body").html();
		$("#gptPopupText").val('');
		$("#gptCustomPromptButtons").hide();
	}
	else
		body = subj + "\n\n" + body;
	
	fetch(HDApp.Url + "Ticket/GetGPTResponse", {
		method: 'POST',
		headers: {
			'Content-Type': 'application/x-www-form-urlencoded',
		},
		body: new URLSearchParams({
			body: body,
			ticketId: HDApp.TicketId,
			command: command
		})
	})
	.then(response => {
		$("#gptPopupOverlay").fadeOut(100, () => {
			$("#gptPopupOverlayIndicator").html("<img src='" + globalRootCdnUrl + "images/indicator.svg' />");
			$("#gptInsertBtns").slideDown();
			clearTimeout(tooLongTimeOut);
			$("#gptTooLongText").hide();
		});
		const reader = response.body.getReader();
		let leftover = "";  // to handle partial data chunks between reads
		var ta = document.getElementById('gptPopupText');

		// content is streamed from the server. The following code reads the stream
		function readStream() {
			return reader.read().then(({ value, done }) => {
				if (done) {
					return;
				}
					
				const chunkText = new TextDecoder("utf-8").decode(value);

				if (chunkText.indexOf('"error":') > -1 || chunkText.indexOf('{"status":') > -1) {
					error = JSON.parse(chunkText);
					handleGPTError(error);

					return;
				}

				const combinedText = leftover + chunkText; // combine leftover with new chunk
				const segments = combinedText.split('data:');

				// The last segment could be incomplete, so save it for the next iteration
				leftover = segments.pop();

				for (const segment of segments) {
					if (segment.trim() === '') continue;  // skip empty segments

					const jsonData = JSON.parse(segment);
					if (jsonData.choices && jsonData.choices.length > 0 && jsonData.choices[0].delta && jsonData.choices[0].delta.content) {
						text = ta.value;
						ta.value = text + jsonData.choices[0].delta.content;
						ta.scrollTop = ta.scrollHeight;
					}
				}
				readStream();
			});
		}

		readStream();
	})
	.catch(error => {
		handleGPTError(error);
	});
		
}
	
function handleGPTError(error) {
	var message = "Unknown error";
	if (error.hasOwnProperty('error'))
		message = error.error.message;
	else if (error.hasOwnProperty('message'))
		message = error.message;
	else if (error.hasOwnProperty('status'))
		message = error.status;
	
	reinitGPTModal();
	alert("There was an error generating the response. Probably the ticket was too long.\n\nInformation for admins:\n\n" + message);
}
function insertGptResponse(replace) {
	var txt = $("#gptPopupText").val();
	txt = txt.replace(/\n/gi, "<br />");
	if (replace === true)
		wswgEditor.Clear();
	wswgEditor.InsertText(txt);
	$.modal.close();
}