﻿//Before including this file into a page make sure you init "HDApp" object with stuff needed (see New.cshtml)

var HDApp = HDApp || { IsTech: false, DisableKB: false, AssignedTo: "Assigned to" }; //stub just for intellisense

//adding some utility methods
HDApp.Url = window.location.href.substring(0, window.location.href.toLowerCase().lastIndexOf("/tickets/"));
HDApp.IsSmartphoneOrTablet = /Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent);

HDApp.catID = -1; // needed for simmilar tickets search, changes to category id, when user changes category in the dropdown list, so we can limit search only in that category

function ShowHideUsers() {
	var cbOnBehalfId = '#OnBehalf';
	var oDiv = document.getElementById("divUsers");

	if (!$(cbOnBehalfId).is(':checked')) {
		$(oDiv).slideUp();
		$('#divUserSelect').show();
		$('#divNewUser').hide();
	}
	else if ($(cbOnBehalfId).is(':checked')) {
		$(oDiv).slideDown();
		$("#OnBehalfUserId_txt").focus();
	}
}

function RefreshCategoryInfo() {
	var categoryId = $('#CategoryID').val();
	RefreshCustomFields(categoryId);
	RefreshTechs(categoryId);
	RefreshCategoryTooltip(categoryId);
	RefreshCategoryTemplate(categoryId);
}
function RefreshCustomFields(categoryID) {
	$.post(HDApp.Url + "/Tickets/RefreshNewTicketCustomFields?categoryId=" + categoryID,
		function (data) {
			var oldValues = $("[id^=CustomFieldValue]");
			$('#CfRow').html(data);
			//restore old values
			oldValues.each(function () {
				var elem = $(this);
				var newElem = $("#" + elem.attr("id"));
				if (newElem.length > 0) {
					newElem.val(elem.val());
				}
			});
			InitDependentFields();
			$('.multiselectCF').multiselect({ minWidth: "100%", header: false });
		});
}

function RefreshTechs(categoryID) {
	if (HDApp.IsTech) {
		if (arguments.length == 0) categoryID = $('#CategoryID').val();

		$.post(HDApp.Url + "/Ticket/GetTechsForCategory?categoryId=" + categoryID, function (data) {
			var sel = $('#selTechId');
			sel.empty();
			sel.append('<option value="" hidden disabled selected>(' + _langStrings.AssignedTo + ')</option>');
			sel.append('<option value="0"></option>');
			for (var i = 0; i < data.length; i++) {
				sel.append('<option value="' + data[i].UserID + '">' + data[i].FullName + ' (' + data[i].TicketsAssigned + ')' + (data[i].OutOfOffice ? " 🏝️" : "") + '</option>');
			}
		});
	}
}

function RefreshCategoryTooltip(categoryID) {
	if (!HDApp.IsSmartphoneOrTablet) {
		$.post(HDApp.Url + "/Tickets/RefreshNewTicketCatNotes?categoryId=" + categoryID, function (data) {
			if (data) {
				//"next" is the dropdown plugin
				var $dropdown = $('#CategoryID').nextAll("div.tooltipstered");
				$dropdown.tooltipster('content', $("<span>" + data + "</span>"));
				$dropdown.tooltipster('show');
				$(document).on('click.tooltipster', function () { $dropdown.tooltipster('hide'); $(document).off('click.tooltipster'); });
			}
		});
	}
}

function RefreshCategoryTemplate(categoryID) {
	if (!categoryID) return;
	if (keyWasPressed) return;
	if (location.search.indexOf("fromIdeaId") > -1 || location.search.indexOf("fromCommentId") > -1) return;
	if (!HDApp.IsSmartphoneOrTablet) {
		$.ajax({ type: "POST", url: HDApp.Url + "/Tickets/GetTicketTemplate?categoryId=" + categoryID })
			.always(function (data) {
				wswgEditor.doCheck();
				if (data && (data.Body || data.Subject)) {
					$('#Subject').val(data.Subject);
					$('#Body').val(data.Body);
				}
				else { //empty template
					$('#Subject').val("");
					$('#Body').val("");
				}
				if (wswgEditor.IsEditorVisible())
					wswgEditor.ShowEditor();
			});
	}
}

var keyWasPressed = false;

function InitEditor(){
	$("#Body").wswgEditor({ checkboxBtn: true });
	$(wswgEditor.getEditorDoc()).on("input", function handler(e) {
		window.onbeforeunload = function () { return "You have unsaved changes."; };
		ProcessCtrlEnter(e, function () { wswgEditor.doCheck(); $("#btnAdd").click(); });
		keyWasPressed = true;
		$(this).off("input", null, handler);
	});
	$("#Subject").on("input", function handler(e) {
		window.onbeforeunload = function () { return "You have unsaved changes."; };
		keyWasPressed = true;
		$(this).off("input", null, handler);
	});
	$(wswgEditor.getEditorDoc()).bind('keyup', function (e) { if (e.which == 13) AutoResizeEditableIframe(wswgEditor.getEditorDoc()); });
	$("#Body").bind('keyup', function (e) { if (e.which == 13) AutoResize($("#Body").get(0)); });
}

$(function () {
	$("#btnAdd").removeAttr("disabled"); // enable the submit button. This is done to prevent submitting the form without JS enabled

	// parse inline images. For example when creating a new ticket from an existing comment
	bodyText = $('#Body').text();
	bodyText = bodyText.replace("src=\"att", "src=\"" + HDApp.Url + "/File/Get/");
	$('#Body').text(bodyText);

	InitEditor();

	if (!HDApp.IsSmartphoneOrTablet) {
		$('#CategoryID').next().tooltipster({ position: 'right', theme: 'my-custom-theme', trigger: 'custom', maxWidth: 500, interactive: true });
	}

	$("#CategoryID").change(function () {
		// setting catId when selection changes for similar tickets search
		HDApp.catID = $('#CategoryID').val();
	});

	$("#newTicket").hide(); //hide green "new ticket" button on the new ticket page to avoid clicks by mistake

	if ($('#YourEmail').is(":visible")) $('#YourEmail').focus();
	else if ($('#CategoryID').val()==-1) $('a.dropdown-toggle').focus(); //focus on category if unset
	else $('#Subject').focus();

	//move canned resp
	$('#selTemplates').insertBefore("#divEditor .boldbtn");

	jQuery.validator.addMethod(
		'OnBehalfEmailValidator',
		function (value) {
			//if on behalf is visible and hidden user id field has no value, it must be an email
			if ($("#OnBehalf:checked").length > 0 && !$("#OnBehalfUserId").val() && !$("#divNewUser:visible").length > 0) {
				var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
				return re.test(value);
			}
			return true;
		},
		'Please enter a valid email address'
	);

	if ($.trim($("#divAdvanced").html()) == '') //hide advanced btn if theres nothing there
		$('#lnkAdvanced').hide();


	$("#btnAdd").click(function (e) {
		window.onbeforeunload = null;
		$("#new-ticket-form").validate({
			ignore: "",
			rules: {
				Subject: {
					required: true,
					maxlength: 255,
					minlength: HDApp.MinChars
				},
				OnBehalfUserId_txt: {
					OnBehalfEmailValidator: true
				},
				Body: {
					required: true,
					minlength: HDApp.MinChars
				}
			},
			submitHandler: function (form) {
				$("#btnAdd").prop("disabled", true);

				if (typeof grecaptcha !== 'undefined')
					grecaptcha.execute();
				else
					form.submit();
			}
		});

		if ($("#new-ticket-form").valid() == false && $('.error:visible').length) {
			$('.error:visible')[0].scrollIntoView({ behavior: 'smooth' }); //scroll error element into view
		}

		return true;
	});

	if ($('#CategoryID').val() != -1) {
		if ($('#Body').val() || $('#Subject').val()) keyWasPressed = true; //if body already prefilled on load - means we're creating ticket from comment or idea - do not preload category template
		RefreshCategoryTemplate($('#CategoryID').val());
	}

	if (!HDApp.DisableKB) {
		var subjTB = $("#Subject");

		subjTB.blur(function () {
			GetSimilar();
		});

		$(wswgEditor.getEditorDoc()).blur(function () {
			//wswgEditor.doCheck(); //commented out - exact same thing is bound in editor.js
			setTimeout(GetSimilar, 1500); //run KB similar check after 1 second delay, in case user just clicked "submit" after filling the body
		});
	}

	//dependent custom fields
	InitDependentFields();

	$('.multiselectCF').multiselect({ minWidth:"100%", header: false });

	//end $(function())
});

function GetSimilar() {
	if ($("#Subject").val().length > 10 && $("#Body").val().length > 100) { //unless value is too short
		var data = {
			subj: $("#Subject").val().trim(),
			body: stripHtml($("#Body").val().trim())
		};

		//compare wtih previous - and exit if nothing changed
		if (window.prevSimilarData && JSON.stringify(window.prevSimilarData) == JSON.stringify(data)) return;

		window.prevSimilarData = data;

		$.ajax({
			type: "POST",
			url: HDApp.Url + "/Tickets/GetSimilarFromKB",
			data: data,
			dataType: "json",
			success: function (msg) {
				if (!msg || msg.length === 0) { $("#similarFromKB").remove(); return; }
				var html = "<div id='similarFromKB'><h4>Similar articles from Knowledge Base</h4><ul class='darkbg outerroundedborder'>";
				$.each(msg, function (k, v) {
					html += "<li><a target='_blank' href='" + HDApp.Url + "/KB/View/" + v.ArticleId + "'>" + v.Subject + "</a></li>";
				});
				html += "</ul></div > "
				if ($("#similarFromKB").length === 0)
					$("#Subject").after(html);
				else
					$("#similarFromKB").html(html);
			}
		});
	}
}

function onRecaptchaFinished() {
	document.getElementById("new-ticket-form").submit();
}

function stripHtml(html) {
	if (!html) return;
	var doc = new DOMParser().parseFromString(html, 'text/html');
	return doc.body.textContent || "";
}

function editLayout(el) {
	//init sortable only on edit start, otherwise breaks onblur, which breaks validation
	Sortable.create(document.querySelector("#tblMain tbody"), {
		filter: '.nodrag',
		handle: '.handle'
	});
	$('.handle').show();
	$(el).hide();
	$('.layoutbuttons').show();
	FileUploadHelper.unbindDragEvents();
}

function saveLayout() {
	var rows = $('#tblMain tbody tr').get().map(el => el.id);
	$.post(HDApp.Url + "/Tickets/SaveLayout", { "rows[]": rows }, function () {
		window.location.reload();
	});
}