﻿var _hdWidget = (function (hdWidget) { // Anonymous "self-invoking" function

	var domWidget; //"contact us" tab
	var domNewTicket; //new ticket form window
	var isShown = false;
	var height = 348; //had to use fixed height for smoother animation and cross-browser support
	var isMobile = false;
	//get helpdesk url
	var loadedscripts = document.getElementsByTagName("script");
	var helpdeskUrl;
	for (i = 0; loadedscripts.length; i++) {
		if (!loadedscripts[i] && !loadedscripts[i].src) continue;

		if (loadedscripts[i].src.includes('support-widget-light.js')) {
			helpdeskUrl = loadedscripts[i].src;
			break;
		}
	}

	helpdeskUrl = helpdeskUrl.split('/').slice(0, -1).join('/');
	helpdeskUrl = helpdeskUrl.split('/').slice(0, -1).join('/') + '/';

	var svg = '<svg xml:space="preserve" version="1.1" viewBox="0 0 500 500"><path d="M160 237h66c22 0 40 18 40 40v16c0 22-18 40-40 40h-38l-27 26c-5 5-9 3-9-4v-23c-18-4-31-20-31-39v-16c0-22 18-40 39-40z" fill="#f2955c"/><path d="M320 138h-86c-32 0-59 27-59 60v25c0 33 27 59 59 59h45l39 40c8 7 14 5 14-6v-35c27-6 47-30 47-58v-25c0-33-27-60-59-60z" fill="#fff"/><path d="M208 211a15 15 0 1 0 29 0 15 15 0 0 0-29 0zm52 0a15 15 0 1 0 29 0 15 15 0 0 0-29 0zm52 0a15 15 0 1 0 29 0 15 15 0 0 0-29 0z" fill="#4c5b6b"/></svg>';

	//load jquery if it's not loaded
	if (!window.jQuery) {
		var script = document.createElement("SCRIPT");
		script.src = 'https://ajax.googleapis.com/ajax/libs/jquery/2.2.4/jquery.min.js';
		script.type = 'text/javascript';
		document.getElementsByTagName("head")[0].appendChild(script);
	}

	// Poll for jQuery to come into existance
	var counter = 0;
	var checkReady = function (callback) {
		if (window.jQuery) {
			callback(); //jquery loaded!! launch callback
		}
		else {
			counter++;
			if (counter > 10) return; //not loaded in 10 attempts - prevent endless loop
			setTimeout(function () { checkReady(callback); }, 200);
		}
	};

	// Start polling...
	checkReady(function () {
		//jquery loaded!!!
		jQuery(function () {
			setDefaults();
			initWidget();
			StyleWidget();
			slideOut();
		});
	});

	function initWidget() {
		domWidget = jQuery("<a></a>");
		domWidget.attr('href', 'https://www.jitbit.com/helpdesk/');
		domWidget.attr('title', hdWidget.text);
		domWidget.html(svg);
		$window = jQuery(window)
		isMobile = $window.width() < 500 || $window.height() < 500;

		domNewTicket = jQuery('<div><iframe id="hdWidgetFrame" style="border:0" width="350" src="about:blank"></iframe></div>');

		domWidget.click(function (e) { e.preventDefault(); ToggleWidget(); });

		//check if we need to autoshow the widget
		if (hdWidget.autoShow > 0 && !isShown)
			setTimeout(function () { ToggleWidget(); }, hdWidget.autoShow * 1000);
		else if (document.cookie.indexOf("activeChat=") > -1)
			setTimeout(function () { if (!isShown) loadFrame(); }, 2000);  // do not show, but load the frame so that we can show the widget when we receive new messages
	}

	function loadFrame() {
		if (domNewTicket.find('#hdWidgetFrame')[0].src == 'about:blank') {
			var iframeUrl = helpdeskUrl + 'Widget/NewWidget?ReferrerUrl=' + encodeURIComponent(location.href)
				+ "&bgcolor=" + encodeURIComponent(hdWidget.bgColor)
				+ "&categoryId=" + hdWidget.categoryId
				+ "&email=" + hdWidget.email
				+ "&hideCategory=" + hdWidget.hideCategory
				+ "&msg=" + encodeURIComponent(hdWidget.msg || "");
			domNewTicket.find('#hdWidgetFrame')[0].src = iframeUrl;
		}
	}

	function reloadFrame() {
		domNewTicket.find('#hdWidgetFrame')[0].src = 'about:blank';
		loadFrame();
	}

	function ToggleWidget() {
		if (!isShown) { //show
			loadFrame();
			domNewTicket.animate({ bottom: '0' });
			domNewTicket.show();
			domWidget.animate({ bottom: (height + 10) + 'px' },
				{
					complete: function () {
						if (domWidget.offset().top < 0) { domWidget.css('top', 0); } //in case its off the screen
					}
				});
			domWidget.html("&#10005;");
			isShown = true;
		} else { //hide
			isShown = false;
			domWidget.css('top', ''); //reset back
			domNewTicket.animate({ bottom: '-' + height + 'px' }, { complete: function () { domNewTicket.hide(); } });
			domWidget.animate({ bottom: '30px' });
			domWidget.html(svg);
		}
		return false;
	}

	function setDefaults() {
		var defaults = {
			text: "Contact us",
			position: "right",
			bgColor: "#4C5B6B",
			fgColor: "#ffffff",
			borderColor: "#fff",
			autoShow: 0,
			hideCategory: 0,
			email: ""
		}
		hdWidget = jQuery.extend(defaults, hdWidget);
	}

	function StyleWidget() {
		domNewTicket.css({
			position: "fixed",
			"border-radius": "10px 10px 0 0",
			'border': '2px solid ' + hdWidget.borderColor,
			'border-bottom': 0,
			bottom: '-' + height + 'px',
			overflow: 'hidden',
			height: height + "px",
			"z-index": 9999999,
			"box-sizing": "content-box",
			'background-color': hdWidget.bgColor,
			display: "none"
		});

		jQuery("iframe", domNewTicket).css({
			"overflow-y": 'hidden',
			"border-radius": "10px 10px 0 0",
			"border-left": "1px solid #444",
			"border-right": "1px solid #444",
			height: height + "px"
		});

		domWidget.css({
			display: 'block',
			position: 'fixed',
			bottom: '30px',
			'font-size': '30px',
			'background-color': hdWidget.bgColor,
			color: hdWidget.fgColor,
			'text-decoration': 'none',
			'border': '2px solid ' + hdWidget.borderColor,
			'border-radius': '50%',
			'font-family': 'sans-serif',
			"z-index": 9999,
			'width': '50px',
			'height': '50px',
			'text-align': 'center',
			'line-height': '49px',
			'box-shadow': '0px 0px 23px 4px rgba(0,0,0,.2)'
		});

		if (!isMobile) {
			if (hdWidget.position == "left") {
				domNewTicket.css("left", '100px');
			}
			else {
				domNewTicket.css("right", '100px');
			}
		}

		if (isMobile) {
			domNewTicket.css({
				"width": "100%"
			})
			jQuery("iframe", domNewTicket).css("width", "100%");
		}
	}

	function slideOut() {
		domNewTicket.css({ "bottom": "-=50" });
		domWidget.css({ "bottom": "-=100" });
		jQuery("body")
			.append(domNewTicket)
			.append(domWidget);

		//we need to wait a second for DOM to refresh
		setTimeout(function () {
			//position "contact us" depending on its width
			//domWidget.width(Math.round(domWidget.outerWidth() - 60)); // round the tab width to int first. Before this the width is a float and it causes sub-pixel aligment issues in all browsers

			var coord = "100px"; if (isMobile) coord = "20px";
			if (hdWidget.position == "left")
				domWidget.css({ left: coord })
			else
				domWidget.css({ right: coord })

			//pretty initial slide out
			domNewTicket.animate({ "bottom": "+=50" });
			domWidget.animate({ "bottom": "+=100" });
		}, 1000);
	}

	window.addEventListener("message", function (e) {
		if (e.data == "setCurrentlyInChat") document.cookie = "activeChat=true";
		if (e.data == "showWidget") {
			if (!isShown) ToggleWidget()
		} 
		if (e.data == "setNotInChat") {
			document.cookie = 'activeChat=;expires=Thu, 01 Jan 1970 00:00:01 GMT;'; // remove the active chat cookie
			reloadFrame();
		}

	}, false);

	return {
		toggleWidget: function () { ToggleWidget() }
	}
})(typeof hdWidget === 'undefined' ? {} : hdWidget);